using Tinkerforge;

class Example
{
	private static string HOST = "localhost";
	private static int PORT = 4223;
	private static string UID = "ABC"; // Change to your UID

	static void Main() 
	{
		IPConnection ipcon = new IPConnection(); // Create IP connection
		BrickletTemperature temp = new BrickletTemperature(UID, ipcon); // Create device object

		ipcon.Connect(HOST, PORT); // Connect to brickd
		// Don't use device before ipcon is connected

		// Get current temperature (unit is °C/100)
		short temperature = temp.GetTemperature();

		System.Console.WriteLine("Temperature: " + temperature/100.0 + " °C");

		System.Console.WriteLine("Press key to exit");
		System.Console.ReadKey();
	}
}
