/* ***********************************************************
 * This file was automatically generated on 2013-01-25.      *
 *                                                           *
 * Bindings Version 2.0.1                                    *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for reading temperatures from Pt100 or Pt1000 sensors
	/// </summary>
	public class BrickletPTC : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>
		/// </summary>
		public static int DEVICE_IDENTIFIER = 226;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPTC.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_TEMPERATURE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPTC.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPTC.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPTC.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPTC.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPTC.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPTC.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPTC.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte CALLBACK_TEMPERATURE = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPTC.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte CALLBACK_TEMPERATURE_REACHED = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPTC.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPTC.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public static char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public static char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public static char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public static char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public static char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletPTC.SetTemperatureCallbackPeriod"/>. The parameter is the temperature
		///  of the sensor.
		///  
		///  <see cref="Tinkerforge.BrickletPTC.Temperature"/> is only triggered if the temperature has changed since the
		///  last triggering.
		/// </summary>
		public event TemperatureEventHandler Temperature;
		/// <summary>
		/// </summary>
		public delegate void TemperatureEventHandler(BrickletPTC sender, int temperature);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletPTC.SetTemperatureCallbackThreshold"/> is reached.
		///  The parameter is the temperature of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletPTC.SetDebouncePeriod"/>.
		/// </summary>
		public event TemperatureReachedEventHandler TemperatureReached;
		/// <summary>
		/// </summary>
		public delegate void TemperatureReachedEventHandler(BrickletPTC sender, int temperature);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletPTC(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			this.apiVersion[0] = 2;
			this.apiVersion[1] = 0;
			this.apiVersion[2] = 0;
			callbackWrappers[CALLBACK_TEMPERATURE] = new CallbackWrapper(OnTemperature);
			callbackWrappers[CALLBACK_TEMPERATURE_REACHED] = new CallbackWrapper(OnTemperatureReached);

			responseExpected[FUNCTION_GET_TEMPERATURE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_TEMPERATURE] = ResponseExpectedFlag.ALWAYS_FALSE;
			responseExpected[CALLBACK_TEMPERATURE_REACHED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  TODO
		///  
		///  If you want to get the temperature periodically, it is recommended 
		///  to use the callback <see cref="Tinkerforge.BrickletPTC.Temperature"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletPTC.SetTemperatureCallbackPeriod"/>.
		/// </summary>
		public int GetTemperature()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_TEMPERATURE);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_TEMPERATURE, out response);

			return LEConverter.IntFrom(8, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletPTC.Temperature"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletPTC.Temperature"/> is only triggered if the temperature has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetTemperatureCallbackPeriod(long period)
		{
			byte[] data_ = MakePacketHeader(12, FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, data_);

			if(GetResponseExpected(FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD))
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletPTC.SetTemperatureCallbackPeriod"/>.
		/// </summary>
		public long GetTemperatureCallbackPeriod()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletPTC.TemperatureReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the temperature is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the temperature is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the temperature is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the temperature is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetTemperatureCallbackThreshold(char option, int min, int max)
		{
			byte[] data_ = MakePacketHeader(17, FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, data_);
			LEConverter.To((int)min, 9, data_);
			LEConverter.To((int)max, 13, data_);

			if(GetResponseExpected(FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD))
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletPTC.SetTemperatureCallbackThreshold"/>.
		/// </summary>
		public void GetTemperatureCallbackThreshold(out char option, out int min, out int max)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.IntFrom(9, response);
			max = LEConverter.IntFrom(13, response);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callback
		///  
		///   <see cref="Tinkerforge.BrickletPTC.TemperatureReached"/>
		///  
		///  is triggered, if the threshold
		///  
		///   <see cref="Tinkerforge.BrickletPTC.SetTemperatureCallbackThreshold"/>
		///  
		///  keeps being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			byte[] data_ = MakePacketHeader(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, data_);

			if(GetResponseExpected(FUNCTION_SET_DEBOUNCE_PERIOD))
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_DEBOUNCE_PERIOD, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletPTC.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_DEBOUNCE_PERIOD, out response);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifiers can be found :ref:`here &lt;device_identifier&gt;`.
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_IDENTITY);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_IDENTITY, out response);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnTemperature(byte[] data_)
		{
			int temperature = LEConverter.IntFrom(8, data_);

			var handler = Temperature;
			if(handler != null)
			{
				handler(this, temperature);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnTemperatureReached(byte[] data_)
		{
			int temperature = LEConverter.IntFrom(8, data_);

			var handler = TemperatureReached;
			if(handler != null)
			{
				handler(this, temperature);
			}
		}
	}
}